



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>转: 如何使用jstack分析线程状态</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">转: 如何使用jstack分析线程状态</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 14:56:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<header>
<h1>这个讲的好系列:&nbsp; 如何使用jstack分析线程状态</h1>
<h1>转:<a href="http://www.jianshu.com/p/6690f7e92f27" rel="external nofollow noreferrer">http://www.jianshu.com/p/6690f7e92f27</a></h1>
</header>
<div>
<div>
<h2>背景</h2>
<p>记得前段时间，同事说他们测试环境的服务器cpu使用率一直处于100%，本地又没有什么接口调用，为什么会这样？cpu使用率居高不下，自然是有某些线程一直占用着cpu资源，那又如何查看占用cpu较高的线程？</p>
<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/2184951-d0d2990160a6c935.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>当然一个正常的程序员不会写出上述代码，这里只是为了让一个线程占用较高的cpu资源。</p>
<h2>top命令</h2>
<p>在linux环境下，可以通过top命令查看各个进程的cpu使用情况，默认按cpu使用率排序</p>
<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/2184951-b61659815716a054.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>1、上图中可以看出pid为23344的java进程占用了较多的cpu资源；</p>
<p>2、通过top -Hp 23344可以查看该进程下各个线程的cpu使用情况；</p>
<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/2184951-831f6716e5801e63.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>上图中可以看出pid为25077的线程占了较多的cpu资源，利用jstack命令可以继续查看该线程当前的堆栈状态。</p>
<h2>jstack命令</h2>
<p>通过top命令定位到cpu占用率较高的线程之后，继续使用jstack pid命令查看当前java进程的堆栈状态</p>
<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/2184951-4abd1324fb6e8b7f.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>jstack命令生成的thread dump信息包含了JVM中所有存活的线程，为了分析指定线程，必须找出对应线程的调用栈，应该如何找？</p>
<p>在top命令中，已经获取到了占用cpu资源较高的线程pid，将该pid转成16进制的值，在thread dump中每个线程都有一个nid，找到对应的nid即可；隔段时间再执行一次stack命令获取thread dump，区分两份dump是否有差别，在nid=0x246c的线程调用栈中，发现该线程一直在执行JstackCase类第33行的calculate方法，得到这个信息，就可以检查对应的代码是否有问题。</p>
<h2>" src="/CuteSoft_Client/CuteEditor/Images/anchor.gif"&gt;" src="/CuteSoft_Client/CuteEditor/Images/anchor.gif"&gt;通过thread dump分析线程状态</h2>
<p>除了上述的分析，大多数情况下会基于thead dump分析当前各个线程的运行情况，如是否存在死锁、是否存在一个线程长时间持有锁不放等等。</p>
<p>在dump中，线程一般存在如下几种状态：</p>
<p>1、RUNNABLE，线程处于执行中</p>
<p>2、BLOCKED，线程被阻塞</p>
<p>3、WAITING，线程正在等待</p>
<h2>实例1：多线程竞争synchronized锁</h2>
<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/2184951-311ab1b4ea7dde3e.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>很明显：线程1获取到锁，处于RUNNABLE状态，线程2处于BLOCK状态</p>
<p>1、locked &lt;0x000000076bf62208&gt;说明线程1对地址为0x000000076bf62208对象进行了加锁；</p>
<p>2、waiting to lock &lt;0x000000076bf62208&gt; 说明线程2在等待地址为0x000000076bf62208对象上的锁；</p>
<p>3、waiting for monitor entry [0x000000001e21f000]说明线程1是通过synchronized关键字进入了监视器的临界区，并处于&#8221;Entry Set&#8221;队列，等待monitor，具体实现可以参考<a href="http://www.jianshu.com/p/c5058b6fe8e5" rel="external nofollow noreferrer">深入分析synchronized的JVM实现；</a></p>
<h2>实例2：通过wait挂起线程</h2>
<pre class="prettyprint linenums">
<ol><li><code>static class Task implements Runnable {</code></li>
<li><code> @Override</code></li>
<li><code> public void run() {</code></li>
<li><code> synchronized (lock) {</code></li>
<li><code> try {</code></li>
<li><code> lock.wait();</code></li>
<li><code> //TimeUnit.SECONDS.sleep(100000);</code></li>
<li><code> } catch (InterruptedException e) {</code></li>
<li><code>                e.printStackTrace();</code></li>
<li><code> }</code></li>
<li><code> }</code></li>
<li><code> }</code></li>
<li><code>}</code></li></ol>
</pre>
<h2>dump结果</h2>
<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/2184951-18d46d5260925392.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>线程1和2都处于WAITING状态<br />1、线程1和2都是先locked &lt;0x000000076bf62500&gt;，再waiting on &lt;0x000000076bf62500&gt;，之所以先锁再等同一个对象，是因为wait方法需要先通过synchronized获得该地址对象的monitor；</p>
<h2><a>说明线程执行了wait方法之后，释放了monitor，进入到&#8221;Wait Set&#8221;队列，等待其它线程执行地址为0x000000076bf62500对象的notify方法，并唤醒自己，具体实现可以参考  深入分析Object.wait/notify实现机制；" class="reference-link" style="box-sizing: border-box; padding: 0px; margin: 0px; background: url(&quot;/CuteSoft_Client/CuteEditor/Load.ashx?type=image&amp;file=anchor.gif&quot;) no-repeat transparent; color: #4183c4; transition: color 300ms ease 0s, background-color 300ms ease 0s; width: 20px; height: 20px; text-indent: 20px;"&gt;</a>2、waiting on &lt;0x000000076bf62500&gt;说明线程执行了wait方法之后，释放了monitor，进入到&#8221;Wait Set&#8221;队列，等待其它线程执行地址为0x000000076bf62500对象的notify方法，并唤醒自己，具体实现可以参考<a href="http://www.jianshu.com/p/f4454164c017" rel="external nofollow noreferrer">深入分析Object.wait/notify实现机制；</a></h2>
<blockquote><p>文／占小狼（简书作者）</p>
<p>原文链接：<a href="http://www.jianshu.com/p/6690f7e92f27" rel="external nofollow noreferrer">http://www.jianshu.com/p/6690f7e92f27</a></p></blockquote>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gjoj09.html">Windows 10 内置管理员无法打开Metro应用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4p6r3q.html">关于mysql数据库插入数据，不能插入中文和出现中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pxzyyq.html">Monkey Android API 翻译</a>
		</li>
						<li><a href="https://www.batexi.com/a/495d01zq.html">ubuntu 13&period;10 monodevelop3 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyo12j8.html">lambda浅尝</a>
		</li>
						<li><a href="https://www.batexi.com/a/4955o4v9.html">JQuery 操作HTML元素 示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7me6rgq.html">Notes of the scrum meeting（12&period;7）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1w77j8.html">redo log write和flush</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0xozgq.html">&lbrack;C&num;&rsqb;判断字符串中是否包含中文</a>
		</li>
						<li><a href="https://www.batexi.com/a/96okrkj9.html">深入浅出 - Android系统移植与平台开发（十）- Android编译系统与定制Android平台系统（瘋耔修改篇二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e16w7m9.html">如何让android sdk manager飞奔安装sdk</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2deg9.html">poj 1273 Drainage Ditches &lpar;网络流 最大流&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oker1p9.html">轻松完成WAP手机网站搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1pdej8.html">英文长单词断行 word-break  VS  word-wrap</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkx3k9.html">struts2&period;1&period;6教程十、类型转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6kgl8.html">自动化运维工具&mdash;&mdash;puppet详解（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1x66xq.html">git只添加指定类型的文件的&period;gitignore规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y04xg8.html">php魔术变量以及命名空间</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyd53gq.html">关于layui中tablle 渲染数据后 sort排序问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd2l7d9.html">2059-authentication plugin &amp;&num;39&semi;caching&lowbar;sha2&lowbar;password&amp;quot&semi;cnnot bt loaded &colon;mysql8&period;0数据库链接不上：</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25ew6oq.html">Linux 文件系统与挂载详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ejewq.html">072 HBase的架构以及各个模块的功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/96020zy9.html">《Gradle权威指南》--Gradle构建脚本基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5pnzeq.html">Python - 经典程序示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvp56l8.html">HDU&period;5909&period;Tree Cutting&lpar;树形DP FWT&sol;点分治&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1p55xq.html">洛谷&period;4172&period;&lbrack;WC2006&rsqb;水管局长&lpar;LCT Kruskal&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wrnk0q.html">python面向对象编程练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e46jkm9.html">Python 线程和进程和协程总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r0ygj9.html">Qt 4&period;6&period;2静态编译后，创建工程出现中文乱码的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw1knv9.html">Linux知识（6）----卸载安装的包</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
